export declare type SecretLintRuleLocaleTag = "en" | "cs" | "de" | "es" | "fr" | "it" | "ja" | "ko" | "pl" | "ru" | "tr" | "zh-CN" | "zh-TW" | string;
export declare type SecretLintRuleLocalizeMessageProps = {
    [index: string]: any;
};
export declare type SecretLintRuleLocalizeMessageHandler<Props extends SecretLintRuleLocalizeMessageProps> = (props?: Props) => string;
export declare type SecretLintRuleLocalizeMessageMulti<Props extends SecretLintRuleLocalizeMessageProps> = {
    [P in SecretLintRuleLocaleTag]: SecretLintRuleLocalizeMessageHandler<Props>;
} & {
    en(props?: Props): string;
};
/**
 * Rule Messages
 *
 * @example
 * const messages = {
 *     messageId: {
 *         en: (props: { key: string }) => `message ${key}`,
 *         ja: (props: { key: string }) => `メッセージ ${key}`
 *     }
 * }
 */
export declare type SecretLintRuleLocalizeMessages = {
    [index: string]: SecretLintRuleLocalizeMessageMulti<any>;
};
export declare type SecretLintRuleMessageTranslateResult<Props extends SecretLintRuleLocalizeMessageProps> = {
    message: string;
    messageId: string;
    data: Props | undefined;
};
declare type ValueOf<T> = T[keyof T];
export declare type SecretLintRuleMessageTranslate<T extends SecretLintRuleLocalizeMessages, MessageId extends keyof T = keyof T, Props extends Parameters<ValueOf<T[MessageId]>>[0] = Parameters<ValueOf<T[MessageId]>>[0]> = (messageId: MessageId, props?: Props) => SecretLintRuleMessageTranslateResult<Props>;
export declare type SecretLintCreateRuleMessageTranslator<T extends SecretLintRuleLocalizeMessages> = (messages: T) => SecretLintRuleMessageTranslate<T>;
export {};
